favouriteVehicles = {}
Citizen.CreateThread(function()
    local result = ExecuteSql("SELECT * FROM `codem_staff_vehicle`")
    for i = 1, #result do
        local resultData = result[i]
        local dataInfo = {
            identifier = resultData.identifier,
            vehiclelist = json.decode(resultData.fav_vehicles),
        }
        if not favouriteVehicles[resultData.identifier] then
            favouriteVehicles[resultData.identifier] = dataInfo
        end
        if Config.CleanSQL == 'onceaweek' then
            if GetFormattedDay() == "sun" then
                dataInfo.spenddata = {
                    ["mon"] = 0,
                    ["tue"] = 0,
                    ["wed"] = 0,
                    ["thu"] = 0,
                    ["fri"] = 0,
                    ["sat"] = 0,
                    ["sun"] = 0
                }
                ExecuteSql('DELETE FROM codem_staff_vehicle WHERE identifier = :identifier',
                    { identifier = resultData.identifier })
            end
        elseif Config.CleanSQL == 'everyrestart' then
            ExecuteSql('DELETE FROM codem_staff_vehicle WHERE identifier = :identifier',
                { identifier = resultData.identifier })
        end
    end
end)

Citizen.CreateThread(function()
    while not Core do
        Wait(0)
    end
    RegisterCallback('codem-staff:server:addFavoriteVehicle', function(source, cb, vehicleData)
        local src = source
        local Player = GetPlayer(src)
        local identifier = GetIdentifier(src)
        if Player and identifier then
            if next(favouriteVehicles[identifier].vehiclelist) == nil then
                favouriteVehicles[identifier] = {
                    identifier = identifier,
                    vehiclelist = {},
                }
                ExecuteSql(string.format(
                    "INSERT INTO codem_staff_vehicle (identifier, fav_vehicles) VALUES ('%s', '%s')", identifier,
                    json.encode({ vehicleData })))
                local insertTable = favouriteVehicles[identifier].vehiclelist
                table.insert(insertTable, vehicleData)
            else
                if favouriteVehicles[identifier] then
                    local currentFavorites = favouriteVehicles[identifier].vehiclelist
                    local alreadyExists = false

                    for _, favVehicle in ipairs(currentFavorites) do
                        if favVehicle.model == vehicleData.model and favVehicle.name == vehicleData.name then
                            alreadyExists = true
                            cb('false')
                            TriggerClientEvent('codem-staff:notification', src,
                                string.format(Config.BackendLocales['vehiclealreadyexists'], vehicleData.name))
                            return
                        end
                    end

                    if not alreadyExists then
                        table.insert(currentFavorites, vehicleData)
                        ExecuteSql(string.format(
                            "UPDATE codem_staff_vehicle SET fav_vehicles = '%s' WHERE identifier = '%s'",
                            json.encode(currentFavorites), identifier))
                    end
                end
            end
            TriggerClientEvent('codem-staff:notification', src,
                string.format(Config.BackendLocales['vehicleaddedtofav'], vehicleData.name))
            cb(favouriteVehicles[identifier].vehiclelist)
        end
    end)

    RegisterCallback('codem-staff:server:removeFavoriteVehicle', function(source, cb, vehicleData)
        local src = source
        local Player = GetPlayer(src)
        local identifier = GetIdentifier(src)
        if Player and identifier then
            if favouriteVehicles[identifier] then
                local currentFavorites = favouriteVehicles[identifier].vehiclelist
                for i, favVehicle in ipairs(currentFavorites) do
                    if favVehicle.model == vehicleData.model and favVehicle.name == vehicleData.name then
                        table.remove(currentFavorites, i)
                        ExecuteSql(string.format(
                            "UPDATE codem_staff_vehicle SET fav_vehicles = '%s' WHERE identifier = '%s'",
                            json.encode(currentFavorites), identifier))
                        TriggerClientEvent('codem-staff:notification', src,
                            string.format(Config.BackendLocales['vehicleremovedfav'], vehicleData.name))
                        cb(favouriteVehicles[identifier].vehiclelist)
                        return
                    end
                end
            end
        end
    end)

    RegisterCallback('codem-staff:server:getFavoriteVehicle', function(source, cb)
        local src = source
        local Player = GetPlayer(src)
        local identifier = GetIdentifier(src)
        if Player and identifier then
            if favouriteVehicles then
                if favouriteVehicles[identifier] == nil then
                    favouriteVehicles[identifier] = {
                        identifier = identifier,
                        vehiclelist = {},
                    }
                end
            end

            cb(favouriteVehicles[identifier])
        end
    end)
    RegisterCallback('codem-staff:server:addVehicleToDatabase', function(source, cb, data)
        local adminData = playerServerData[GetIdentifier(source)]

        local checkPermission = CheckPermission(adminData.rankdata.rank, 'givevehicledb')
        if not checkPermission and not adminData.rankdata.owner then
            TriggerClientEvent('codem-staff:notification', source, Config.BackendLocales['notauthorized'])
            return
        end

        if type(data) == 'string' then
            vehicleName = data
        else
            vehicleName = data.vehicleName
            playerID = tonumber(data.playerID)
            sendVehicle = data.sendVehicle
        end
        local src = source
        if not playerID then
            playerID = src
        end
        local Player = GetPlayer(tonumber(playerID))
        local identifier = GetIdentifier(playerID)
        if identifier == nil then
            TriggerClientEvent('codem-staff:notification', src, Config.BackendLocales['notfoundplayer'])
            cb('false')
            return
        end
        vehicleName = string.gsub(vehicleName, "%s+", "")
        local plate = GeneratePlate()
        if GetResourceState("m-vehicleshop") == 'started' then
            plate = exports['m-vehicleshop']:GeneratePlate()
        end
        local vehicleProps = GetVehicleProperties(vehicleName, plate)
        if Player then
            if Config.Framework == 'esx' then
                local garage = 'SanAndreasAvenue'
                if identifier and plate and vehicleProps then
                    ExecuteSql(string.format(
                        "INSERT INTO owned_vehicles (owner, plate, vehicle, stored, parking) VALUES ('%s', '%s', %q, '%s', '%s')",
                        identifier, plate, json.encode(vehicleProps), "1", garage))
                end
            elseif Config.Framework == 'oldesx' then
                if identifier and plate and vehicleProps then
                    ExecuteSql(string.format(
                        "INSERT INTO owned_vehicles (owner, plate, vehicle) VALUES ('%s', '%s', %q)", identifier, plate,
                        json.encode(vehicleProps)))
                end
            elseif Config.Framework == 'qb' or Config.Framework == 'newqb' then
                local garage = 'pillboxgarage'
                ExecuteSql(string.format(
                    "INSERT INTO `player_vehicles` (license, citizenid, vehicle, hash, mods, plate, garage) VALUES ('%s', '%s', '%s', '%s', %q, '%s', '%s')",
                    Player.PlayerData.license, identifier, vehicleName, GetHashKey(vehicleName),
                    json.encode(vehicleProps),
                    plate, garage))
            end
            TriggerClientEvent('codem-staff:notification', src,
                string.format(Config.BackendLocales['vehicleaddedtodb'], vehicleName))
                if discord_webhook["addvehicledatabase"].allow and discord_webhook["addvehicledatabase"].webhook ~= "" then
                    discordLogStaff(tonumber(src), tonumber(playerID) or src, discord_webhook["addvehicledatabase"].text.. vehicleName, 'addvehicledatabase')
                end
            if sendVehicle then
                cb(GetPlayerVehicles(tonumber(playerID)))
            else
                cb(true)
            end
        end
    end)
end)

RegisterServerEvent('codem-staff:server:giveVehicleToPlayer', function(vehicleName, playerID)
    local src = source
    local adminData = playerServerData[GetIdentifier(src)]
    local checkPermission = CheckPermission(adminData.rankdata.rank, 'givevehicle')
    if not checkPermission and not adminData.rankdata.owner then
        TriggerClientEvent('codem-staff:notification', src, Config.BackendLocales['notauthorized'])
        return
    end
    if not playerID then
        playerID = src
    end

    TriggerClientEvent('codem-staff:client:giveVehicle', tonumber(playerID), vehicleName)
    TriggerClientEvent('codem-staff:notification', src,
        string.format(Config.BackendLocales['vehiclegiventoplayer'], vehicleName))
end)

RegisterServerEvent('codem-staff:server:giveVehicleToPlayerCommand', function(data)
    local adminData = playerServerData[GetIdentifier(tonumber(data.source))]
    local checkPermission = CheckPermission(adminData.rankdata.rank, 'givevehicle')
    if not checkPermission and not adminData.rankdata.owner then
        TriggerClientEvent('codem-staff:notification', tonumber(data.source), Config.BackendLocales['notauthorized'])
        return
    end

    TriggerClientEvent('codem-staff:client:giveVehicle', tonumber(data.playerID), data.value)
    TriggerClientEvent('codem-staff:notification', tonumber(data.source),
        string.format(Config.BackendLocales['vehiclegiventoplayer'], data.value))
end)

function Round(value, numDecimalPlaces)
    if numDecimalPlaces then
        local power = 10 ^ numDecimalPlaces
        return math.floor((value * power) + 0.5) / (power)
    else
        return math.floor(value + 0.5)
    end
end

function GetVehicleProperties(name, plate)
    local extras = {}
    for i = 1, 12 do
        extras[i] = false
    end
    if Config.Framework == 'esx' or Config.Framework == 'oldesx' then
        return {
            model                = GetHashKey(name),
            plate                = plate,
            plateIndex           = 0,

            bodyHealth           = Round(1000, 1),
            engineHealth         = Round(1000, 1),
            tankHealth           = Round(1000, 1),

            fuelLevel            = Round(100, 1),
            dirtLevel            = Round(0, 1),
            color1               = 0,
            color1Custom         = { 255, 255, 255 },

            color2               = 0,
            color2Custom         = { 255, 255, 255 },

            color1Type           = 0,
            color2Type           = 0,
            customPrimaryColor   = { 255, 255, 255 },
            customSecondaryColor = { 255, 255, 255 },

            pearlescentColor     = 111,
            wheelColor           = 156,

            wheels               = 0,
            windowTint           = -1,
            xenonColor           = 255,

            neonEnabled          = {
                false,
                false,
                false,
                false
            },

            neonColor            = { 255, 0, 255 },
            extras               = extras,
            tyreSmokeColor       = { 255, 255, 255 },
            dashboardColor       = 0,
            interiorColor        = 0,
            modSpoilers          = -1,
            modFrontBumper       = -1,
            modRearBumper        = -1,
            modSideSkirt         = -1,
            modExhaust           = -1,
            modFrame             = -1,
            modGrille            = -1,
            modHood              = -1,
            modFender            = -1,
            modRightFender       = -1,
            modRoof              = -1,

            modEngine            = -1,
            modBrakes            = -1,
            modTransmission      = -1,
            modHorns             = -1,
            modSuspension        = -1,
            modArmor             = -1,

            modTurbo             = false,
            modSmokeEnabled      = false,
            modXenon             = false,

            modFrontWheels       = -1,
            modBackWheels        = -1,

            modPlateHolder       = -1,
            modVanityPlate       = -1,
            modTrimA             = -1,
            modOrnaments         = -1,
            modDashboard         = -1,
            modDial              = -1,
            modDoorSpeaker       = -1,
            modSeats             = -1,
            modSteeringWheel     = -1,
            modShifterLeavers    = -1,
            modAPlate            = -1,
            modSpeakers          = -1,
            modTrunk             = -1,
            modHydrolic          = -1,
            modEngineBlock       = -1,
            modAirFilter         = -1,
            modStruts            = -1,
            modArchCover         = -1,
            modAerials           = -1,
            modTrimB             = -1,
            modTank              = -1,
            modWindows           = -1,
            modDoorR             = -1,
            modLivery            = -1,
            modLightbar          = -1,
            livery               = -1,
        }
    else
        return {
            model             = GetHashKey(name),
            plate             = plate,
            plateIndex        = 0,
            bodyHealth        = Round(1000, 0.1),
            engineHealth      = Round(1000, 0.1),
            tankHealth        = Round(1000, 0.1),
            fuelLevel         = Round(100, 0.1),
            dirtLevel         = Round(0, 0.1),

            color1            = 0,
            color2            = 0,

            pearlescentColor  = 111,
            wheelColor        = 156,
            dashboardColor    = 0,
            interiorColor     = 0,
            wheels            = 0,
            windowTint        = -1,
            xenonColor        = 255,
            neonEnabled       = {
                false,
                false,
                false,
                false
            },
            neonColor         = { 255, 0, 255 },
            extras            = extras,
            tyreSmokeColor    = { 255, 255, 255 },
            modSpoilers       = -1,
            modFrontBumper    = -1,
            modRearBumper     = -1,
            modSideSkirt      = -1,
            modExhaust        = -1,
            modFrame          = -1,
            modGrille         = -1,
            modHood           = -1,
            modFender         = -1,
            modRightFender    = -1,
            modRoof           = -1,
            modEngine         = -1,
            modBrakes         = -1,
            modTransmission   = -1,
            modHorns          = -1,
            modSuspension     = -1,
            modArmor          = -1,
            modTurbo          = false,
            modSmokeEnabled   = false,
            modXenon          = false,
            modFrontWheels    = -1,
            modBackWheels     = -1,
            modCustomTiresF   = false,
            modCustomTiresR   = false,
            modPlateHolder    = -1,
            modVanityPlate    = -1,
            modTrimA          = -1,
            modOrnaments      = -1,
            modDashboard      = -1,
            modDial           = -1,
            modDoorSpeaker    = -1,
            modSeats          = -1,
            modSteeringWheel  = -1,
            modShifterLeavers = -1,
            modAPlate         = -1,
            modSpeakers       = -1,
            modTrunk          = -1,
            modHydrolic       = -1,
            modEngineBlock    = -1,
            modAirFilter      = -1,
            modStruts         = -1,
            modArchCover      = -1,
            modAerials        = -1,
            modTrimB          = -1,
            modTank           = -1,
            modWindows        = -1,
            modLivery         = 0,
        }
    end
end

local StringCharset = {}
local NumberCharset = {}

for i = 48, 57 do NumberCharset[#NumberCharset + 1] = string.char(i) end
for i = 65, 90 do StringCharset[#StringCharset + 1] = string.char(i) end
for i = 97, 122 do StringCharset[#StringCharset + 1] = string.char(i) end

function RandomStr(length)
    if length <= 0 then return '' end
    return RandomStr(length - 1) .. StringCharset[math.random(1, #StringCharset)]
end

function RandomInt(length)
    if length <= 0 then return '' end
    return RandomInt(length - 1) .. NumberCharset[math.random(1, #NumberCharset)]
end

function GeneratePlate()
    local tableName = 'player_vehicles'
    local plate = RandomInt(1) .. RandomStr(2) .. RandomInt(3) .. RandomStr(2)

    if Config.Framework == 'esx' or Config.Framework == 'newesx' then
        tableName = 'owned_vehicles'
        plate = RandomStr(3) .. ' ' .. RandomInt(3)
    end
    plate = plate:upper()
    local result = ExecuteSql(string.format("SELECT plate FROM %s WHERE plate = '%s'", tableName, plate))
    if result[1] then
        return GeneratePlate()
    else
        return plate:upper()
    end
end
